Index: BOL/LMDZ_Setup_amaury/lmdz_env.sh
===================================================================
--- BOL/LMDZ_Setup_amaury/lmdz_env.sh	(revision 4958)
+++ BOL/LMDZ_Setup_amaury/lmdz_env.sh	(revision 4978)
@@ -46,6 +46,22 @@
     LMDZ_INIT=$STORE/LMDZ_Init
     ;;
+  spiri)
+    module purge
+    module load subversion/1.13.0
+    module load gcc/11.2.0
+    module load openmpi/4.0.7
+
+    root_dir=~/"LMDZ_SETUP_ROOT/LMDZ_Setup";
+    ARCH="X64_MESOIPSL-GNU"
+    SIMRUNBASEDIR="$SCRATCH/"
+    LMDZD="$root_dir/LMDZD"
+    LMDZ_INIT="$root_dir/LMDZ_Init"
+    NB_MPI_MAX=20
+    NB_OMP_MAX=1
+    RUNCMD="srun --label -n"
+    SUBMITCMD="sbatch"
+    ;;
   adast)
-#    module purge
+    module purge
 #    module load PrgEnv-gnu
 #    module load cray-hdf5-parallel
@@ -58,6 +74,6 @@
     LMDZD="$root_dir/LMDZD"
     LMDZ_INIT="$root_dir/LMDZ_Init"
-    NB_MPI_MAX=2000
-    NB_OMP_MAX=20
+    NB_MPI_MAX=20  # TODO 2000 in JZ
+    NB_OMP_MAX=2  # TODO 20 in JZ
     RUNCMD="srun --label --account=$account -n"
     SUBMITCMD="sbatch --account=$account"
Index: BOL/LMDZ_Setup_amaury/script_SIMU
===================================================================
--- BOL/LMDZ_Setup_amaury/script_SIMU	(revision 4958)
+++ BOL/LMDZ_Setup_amaury/script_SIMU	(revision 4978)
@@ -16,4 +16,27 @@
 #@JZ# To submit to test queue ; "time" (above) must be max 30 min
 #@JZ#TESTQ#SBATCH --qos=qos_cpu-dev
+#@SP#Spirit
+#@SP#SBATCH --job-name=NOM_SIMU
+#@SP#SBATCH --ntasks=8
+#@SP#SBATCH --cpus-per-task=8
+#@SP#SBATCH --hint=nomultithread
+#@SP#SBATCH --time=00:30:00
+#@SP#SBATCH --output=outNOM_SIMU%j
+#@SP#SBATCH --error=outNOM_SIMU%j#@SP#Spirit
+#@SP#SBATCH --job-name=NOM_SIMU
+#@SP#SBATCH --ntasks=8
+#@SP#SBATCH --cpus-per-task=8
+#@SP#SBATCH --hint=nomultithread
+#@SP#SBATCH --time=00:30:00
+#@SP#SBATCH --output=outNOM_SIMU%j
+#@SP#SBATCH --error=outNOM_SIMU%j
+#@ADS#Adastra
+#@ADS#SBATCH --job-name=NOM_SIMU
+#@ADS#SBATCH --ntasks=8
+#@ADS#SBATCH --cpus-per-task=8
+#@ADS#SBATCH --hint=nomultithread
+#@ADS#SBATCH --time=00:30:00
+#@ADS#SBATCH --output=outNOM_SIMU%j
+#@ADS#SBATCH --error=outNOM_SIMU%j
 
 set -ex
Index: BOL/LMDZ_Setup_amaury/setup.sh
===================================================================
--- BOL/LMDZ_Setup_amaury/setup.sh	(revision 4958)
+++ BOL/LMDZ_Setup_amaury/setup.sh	(revision 4978)
@@ -74,4 +74,6 @@
   case ${hostname:0:5} in
     jean-) platform="JZ";;
+    spiri) platform="SP";;
+    adast) platform="ADS";;
     *) echo "Warning: $hostname is not a known job platform (ignore if running locally)"; return 0;;
   esac
@@ -233,9 +235,10 @@
   cp "$local/install_lmdz.sh" .
   chmod +x install_lmdz.sh
-  # TODO handle arch/env here (used to be -env-file)
   echo "./install_lmdz.sh -noclean $optim -v $version $svnopt -d $resol -rad $rad -bench 0 -parallel mpi_omp $ins_cosp $ins_xios $ins_aero $ins_inlandsis -name $LMDZname -veget $veget -netcdf 0 -arch $ARCH" >> install_lmdz_options.$$.sh
   chmod +x install_lmdz_options.$$.sh
   echo "Running install_lmdz_options.$$.sh"
+  set -o pipefail
   gcm=$MODEL/$(./install_lmdz_options.$$.sh | tee /dev/tty | tail -n 1 | sed -n "s:.* executable is \(.*\.e\).*:\1:p")
+  set +o pipefail
   mv install_lmdz.sh install_lmdz.$$.sh
   cd "$local"
@@ -599,14 +602,30 @@
 #@JZ#JeanZay
 #@JZ#SBATCH --job-name=Init         # nom du job
-#@JZ#SBATCH --ntasks=1             # Nombre de processus MPI
-#@JZ#SBATCH --cpus-per-task=16     # nombre de threads OpenMP
+#@JZ#SBATCH --ntasks=1              # Nombre de processus MPI
+#@JZ#SBATCH --cpus-per-task=16      # nombre de threads OpenMP
 #@JZ# /!\ Attention, la ligne suivante est trompeuse mais dans le vocabulaire
-#@JZ# de Slurm "multithread" fait bien rÃ©fÃ©rence Ã  l'hyperthreading.
-#@JZ#SBATCH --hint=nomultithread   # 1 thread par coeur physique (pas d'hyperthreading)
-#@JZ#SBATCH --time=00:10:00            # Temps dâ€™exÃ©cution maximum demandÃ© (HH:MM:SS)
+#@JZ# de Slurm "multithread" fait bien référence à l'hyperthreading.
+#@JZ#SBATCH --hint=nomultithread    # 1 thread par coeur physique (pas d'hyperthreading)
+#@JZ#SBATCH --time=00:10:00         # Temps d'exécution maximum demandé (HH:MM:SS)
 #@JZ#SBATCH --output=Init%j.out     # Nom du fichier de sortie
 #@JZ#SBATCH --error=Init%j.out      # Nom du fichier d'erreur (ici commun avec la sortie)
 #@JZ# To submit to dev queue; "time" (above) must be max 2h
 #@JZ# #SBATCH --qos=qos_cpu-dev
+#@SP#Spirit
+#@SP#SBATCH --job-name=Init
+#@SP#SBATCH --ntasks=1
+#@SP#SBATCH --cpus-per-task=16
+#@SP#SBATCH --hint=nomultithread
+#@SP#SBATCH --time=00:10:00
+#@SP#SBATCH --output=Init%j.out
+#@SP#SBATCH --error=Init%j.out
+#@ADS#Adastra
+#@ADS#SBATCH --job-name=Init
+#@ADS#SBATCH --ntasks=1
+#@ADS#SBATCH --cpus-per-task=16
+#@ADS#SBATCH --hint=nomultithread
+#@ADS#SBATCH --time=00:10:00
+#@ADS#SBATCH --output=Init%j.out
+#@ADS#SBATCH --error=Init%j.out
 
 # ANCIEN MULTI STEP  case \${LOADL_STEP_NAME} in